<template>
  <div class="input-range">
    <slot name="label" :label="label" :value="value">
      <p class="input-range__label">
        {{ label }}:
        <span class="input-range__value">
          {{ value }}
        </span>
      </p>
    </slot>

    <div class="input-range__wrapper">
      {{ min }}
      <input
        class="input-range__slider"
        type="range"
        :name="id"
        :id="id"
        :min="min"
        :max="max"
        :value="value"
        :step="step"
        @input="updateValue($event.target.value)"
      />
      {{ max }}
    </div>
  </div>
</template>

<script>
export default {
  name: "InputRange",
  props: {
    id: { type: String, required: true },
    label: { type: String, required: true },
    max: { type: Number, default: 100 },
    min: { type: Number, default: 0 },
    step: { type: Number, default: 1 },
    value: { type: String | Number },
  },
  methods: {
    updateValue(value) {
      this.$emit("input", value);
    },
  },
};
</script>

<style lang="scss" scoped>
  .input-range {
    display: flex;
    flex-direction: column;
    align-items: center;

    &__value {
      font-size: 1.5rem;
    }

    &__wrapper {
      display: flex;
      gap: 8px;
    }

    &__label {
      width: 100%;
      max-width: 176px;
      margin-bottom: 2px;
    }

    &__slider {
      -webkit-appearance: none;
      background: transparent;

      &::-webkit-slider-runnable-track {
        height: 2px;
        background: black;
        border-radius: 8px;
      }

      &::-webkit-slider-thumb {
        -webkit-appearance: none;
        margin-top: -6px;
        background: black;
        height: 14px;
        width: 14px;
        border-radius: 50%;
        cursor: pointer;
      }

      &::-moz-range-track {
        -webkit-appearance: none;
        height: 2px;
        background: black;
        border-radius: 8px;
      }

      &::-moz-range-thumb {
        -webkit-appearance: none;
        margin-top: -6px;
        background: black;
        height: 14px;
        width: 14px;
        border-radius: 50%;
        cursor: pointer;
      }
    }
  }
</style>
